#include <sfr51.inc>          
      cseg at 0             
      rtd equ 49801


MOV P3,#FFh ;inicializa P3
MOV P1,#FFh ;inicializa P1

Inicio:

;-----------------------------ler valor1 e guardar em R1

lcall atraso_total  ;chama atraso para ter tempo para a pressao no interruptor
SETB P3.7           ;garante o bit a '1' em P3.7

Valor1:
      JB P3.7,Valor1    ;verifica se o interruptor foi pressionado
      CLR P3.6              ;limpa bit usado para traduzir o erro

      LCALL LeValor     ;chama a subrotina para ler o valor de P1
      MOV R1,A          ;guarda o 1 valor lido em R1
      LCALL MostraValor ;chama a subrotina para mostrar o valor lido

;-----------------------------ler valor2 e guardar em R2

lcall atraso_total  ;chama atraso para ter tempo para a pressao no interruptor
SETB P3.7           ;garante o bit a '1' em P3.7

Valor2:
      JB P3.7,Valor2    ;verifica se o interruptor foi pressionado
      LCALL LeValor     ;chama a subrotina para ler o valor de P1
      MOV R2,A          ;guarda o 2 valor lido em R2
      LCALL MostraValor ;chama a subrotina para mostrar o valor lido

;-----------------------------
lcall atraso_total  ;chama atraso para ter tempo para a pressao no interruptor
SETB P3.7           ;garante o bit a '1' em P3.7

op:
      JB P3.7,op    ;verifica se o interruptor foi pressionado

;-----------------------------ler operacao (00-add, 01-sub, 10-mul, 11-div) e guarda em R0
;
      MOV A,P3      ;guarda o valor de P3 em A
      ANL A,#11b    ;limpa todos os bits do registo excepto os da operacao
      MOV R0,A      ;guarda qual a operao em R0

;-----------------------------guardar valor1 em A e valor2 em B

      MOV A,R1      ;recupera o 1 valor lido e guarda em A
      MOV B,R2      ;recupera o 2 valor lido e guarda em B

;-----------------------------verifica se a operacao  uma soma

      CJNE R0,#0b,Subtration    ;confirma se a operao  uma soma
                                ;se no for vai verificar se  uma subtrao                                

      ADD A,B                   ;faz a adio dos valores
      SJMP Resultado            ;salta para o resultado

;-----------------------------verifica se a operacao  uma subtraccao
Subtration:
      CJNE R0,#1b,Multiplication    ;confirma se a operao  uma subtrao
                                    ;se no for vai verificar se  uma multiplicao

      CLR C                     ;limpa a carry para se poder fazer a subtrao
      SUBB A,B                  ;far a subtrao de valores
      SJMP Resultado            ;salta para o resultado

;-----------------------------verifica se a operacao  uma multiplicacao
Multiplication:
      CJNE R0,#10b,Division    ;confirma se a operao  uma subtrao
                               ;se no for vai verificar se  uma diviso

      MUL AB                ;faz a multiplicao de valores
      SJMP Resultado        ;salta para o resultado

;-----------------------------verifica se a operacao  uma divisao
Division:
      DIV AB                ;faz a diviso de valores
      SJMP Resultado        ;salta para o resultado

;-----------------------------subrotina para ler valor em BCD de P1
                                ;e converter para Binario para A

LeValor:
    MOV A,P1                ;guarda o valor de P1 em A
    MOV R7,A                ;guarda o valor de A
    ANL A,#11110000b        ;limpa o 1 numero em BCD de A
    SWAP A                  ;passa o 1 numero em BCD para os ultimos bits do registo A
    MOV B,#10               ;guarda o valor 10 em B
    MUL AB                  ;multiplica o 1 valor por 10
    MOV B,R7                ;recupera o valor de A e guarda-o no registo B
    ANL B,#1111b            ;limpa o 2 numero em BCD do valor lido
    ADD A,B                 ;junta os dois valores
RET

;-----------------------------subrotina para converter valor Binario de A em BCD e mostrar em P2
MostraValor:    
    MOV B,#10               ;guarda o valor 10 em B
    DIV AB                  ;separa os dois numeros do registo A
    SWAP A                  ;passa o 1 valor de A para os primeiros bits do registo A
    ADD A,B                 ;junta os dois valores
    MOV P2,A                ;passa o valor em BCD para P2
RET

;-----------------------------subrotina para verificar n's maiores que 99    
VerificaNumero:
    MOV R0,A                ;guarda o valor de A em R0
    MOV B,#100              ;guarda o valor 100 em B
    DIV AB                  ;divide o valor por 100

    CJNE A,#0,Erro          ;se a divisao do valor por 100 for maior ou igual a 1
                            ;significa que o valor do registo  maior ou igual a 100
                            ;e se for salta para a label erro

    SJMP Fim              ;salta para o final
Erro:
      SETB P3.6             ;se for erro activa o bit

Fim:

    MOV A,R0                ;recupera o valor de A guardado em R0
RET

;-----------------------------mostra o resultado
Resultado:

LCALL VerificaNumero        ;chama rotina para verificar se o numero  maior que 99
      LCALL MostraValor     ;chama a subrotina para mostrar o resultado


sjmp Inicio                 ;volta ao inicio do programa

;-----------------------------Rotina Atraso
atraso_total:
      lcall Atraso
      lcall Atraso
      lcall Atraso
      lcall Atraso
      lcall Atraso
ret


Atraso: mov R7, #High(rtd) ;move para R7 a parte mais significativa de RTD
        inc R7 ;incrementa R7
        mov R6, #Low(rtd) ;move para R6 a parte menos significativa de RTD
      L2: djnz R6, L2 ;Decrementa R6 e salta para L2 enquanto no for zero
          djnz R7, L2 ;Decrementa R7 e salta para L2 enquanto no for zero
          Nop ;Durante um ciclo de maquina o micro no faz nada de modo a compensar o tempo pertendido
ret ;Sai da rotina para o programa principal    

END